#ifndef MAIN_H_
#define MAIN_H_
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include "nicodef.h"
#include "struct_define.h"
#include "chat/chat.h"
#include "chat/chat_slot.h"

struct CDATA{
	int enable_comment;
	CHAT chat;
	CHAT_SLOT slot;
};

struct DATA{
	FILE* log;
	TTF_Font* font[CMD_FONT_MAX];
	SDL_Surface* screen;
	/*ꂼ̃Rgɉf[^*/
	//[URg
	CDATA user;
//	int enable_user_comment;
//	CHAT chat;
//	CHAT_SLOT slot;
	//e҃Rg
	CDATA owner;
//	int enable_owner_comment;
//	CHAT ownerchat;
//	CHAT_SLOT ownerslot;
	//IvViRg
	CDATA optional;
//	int enable_optional_comment;
//	CHAT optionalchat;
//	CHAT_SLOT optionalslot;
	//ʓIȃf[^
	int shadow_kind;
	int show_video;
	int fontsize_fix;
	int opaque_comment;
	int optional_trunslucent;
	int process_first_called;
	int video_length;
//	int aspect100;		// AXyNg*100	Not used now
	int nico_width_now;	// ̉
	float font_h_fix_r;	// tHg̍nicoplayer.swfɍ킹{(0< <2)iIj
	int original_resize;	// ΂ƎTCYLiftHgLj
	int comment_speed;	// Rgxw肷ꍇ0
	int debug;
//	int limit_height;
	// Iݒ聫
	short font_pixel_size[CMD_FONT_MAX];
	short fixed_font_size[CMD_FONT_MAX];	// CtHgw(|Cgw)
/*
	// short font_height_rate;	// tHg̍jRɍ킹{iAXyNgɂj
	short next_h_rate;	// Rg̍̎̍Ƃ̍i%jiAXyNgɂj
	short next_h_pixel;	// Rg̍̎̍Ƃ̍ipxj(4:3,16:9)
	short limit_width[2];	// ՊETCYim[}Atj
	short double_resize_width[2];	// _uTCYJnim[}Atj
	short limit_height;	// e[hJn̍iAXyNgɂj
	short font_scaling;	//data->font[]̃tHgTCỸXP[O{
	short double_limit_width[2];	// _uTCYՊEim[}Atj
	short debug_key;	// fobOL[
	short target_width;	// ϊ̉Aw肪ȂΌ̉
	//  jRɑ΂Q{P^Q{̃XP[̎ɃtHgzoomȂ
	//  TRUE OR FALSE
	short limitwidth_resize;	// ՊETCYLiftHgLj
	short linefeed_resize;	// sTCYLiftHgLj
	short double_resize;		// _uTCYLiftHgLj
	short font_double_scale;		// tHgTCYCLiftHg2{TCYLj
*/
};

typedef struct SETTING{
	const char* data_user_path;
	const char* data_owner_path;
	const char* data_optional_path;
	const char* font_path;
	int video_length;
	// Vffmpegvideo̎ԂႤInterface܂ő
	// ΂niAs̏ꍇ́@0@or@-1j
	// Rg\̍Ō̒Ȃ̂łȂĂ䖝悤ɕύXB
	// KvȂȂ
	int font_index;
	int user_slot_max;
	int owner_slot_max;
	int optional_slot_max;
	int shadow_kind;
	int nico_width_now;	// ̉
	/*TRUE OR FALSE*/
	int enable_user_comment;
	int enable_owner_comment;
	int enable_optional_comment;
	int show_video;
	int fontsize_fix;
	int opaque_comment;
	int optional_trunslucent;
	// R~jeBł͒ʏRgIvViXbhƂĔɂĂ邽߁AI\ɂ
	float font_h_fix_r;	// tHg̍nicoplayer.swfɍ킹{iIj
	int original_resize;	// ΂ƎTCYLiftHgLj
	int comment_speed;	// Rgxw肷ꍇ0
	int debug;
/*
	// Iݒ聫
	short font_height_rate[2];	// tHg̍jRɍ킹{i4:3,16:9j
	short nico_limit_width[2];	// ՊETCYim[}Atj
	short double_resize_width[2];	// _uTCYJnim[}Atj
	short nico_limit_height[2];	// e[hJn̍i4:3,16:9j
	short next_h_rate[2];	// Rg̍̎̍Ƃ̍i%ji4:3,16:9j
	short next_h_pixel[2];	// Rg̍̎̍Ƃ̍ipxj(4:3,16:9)
	short double_limit_width[2];	// _uTCYՊEim[}Atj
	short fixed_font_size[CMD_FONT_MAX];	// CtHgw(|Cgw)
	short debug_key;	// fobOL[
	short target_width;	// IvVϊ̉XNCsOAw肪ȂΌ̉
	//  jRɑ΂Q{P^Q{̃XP[̎ɃtHgzoomȂ
	//  TRUE OR FALSE
	short limitwidth_resize;	// ՊETCYLiftHgLj
	short linefeed_resize;	// sTCYLiftHgLj
	short double_resize;		// _uTCYLiftHgLj
	// obsolate
	//short font_double_scale;		// tHgTCYCLiftHg2{TCYLj
*/
}SETTING;

int init(FILE* log);
int initData(DATA* data,FILE* log,const SETTING* setting);
int main_process(DATA* data,SDL_Surface* surf,const int now_vpos);
int closeData(DATA* data);
int close();

#endif /*MAIN_H_*/
